#ifndef SIEQUEUE_H
#define SIEQUEUE_H
//----------------------------------------------------------
#include <list>
#include "sietransact.h"
#include "sieobject.h"

//----------------------------------------------------------

class sieQueue : public sieObject
{
	Q_OBJECT
public:
	sieQueue(QObject* parent,const char* name,int num);
	~sieQueue();
	virtual void tic(int time=0);
	virtual void init();
	virtual bool interchange(sieTransact* tr);
	virtual bool isReady() {return currentTransactNum<maxTransactNum;}
	int maxNumber() {return maxTransactNum;}
	void setMaxNumber(int k) {maxTransactNum=k;}

private:
	std::list<sieTransact*> transacts;
	int maxTransactNum;
	int currentTransactNum;
};

//----------------------------------------------------------

#endif
