#ifndef SIEDEVICE_H
#define SIEDEVICE_H
//----------------------------------------------------------
#include "sieobject.h"
//----------------------------------------------------------

class sieDevice : public sieObject
{
	Q_OBJECT
public:
	sieDevice(QObject* parent,const char* name,int delay=-1,int disp=-1);
	~sieDevice();
	virtual void tic(int time=0);
	virtual bool interchange(sieTransact* tr);
	virtual bool isReady(int type) {type=type; return transact==0;}
	virtual void init();
	int delay() {return delayTime;}
	int dispersion() {return dispTime;}
	void setDelay(int k) {delayTime=k;}
	void setDispersion(int k) {dispTime=k;}
private:
	int delayTime;
	int dispTime;
};

//----------------------------------------------------------

#endif
