#ifndef SIETERMINATOR_H
#define SIETERMINATOR_H
//----------------------------------------------------------
#include "sieobject.h"
//----------------------------------------------------------
struct sieTransact;
struct sieTransactList;
//----------------------------------------------------------

class sieTerminator : public sieObject
{
	Q_OBJECT
	   
public:
	sieTerminator(QObject* parent,const char* name,sieTransactList* trList,int numdec);
	~sieTerminator();
	virtual void tic(int time=0);
	virtual bool interchange(sieTransact* tr);
	int decrementNumber() {return numDec;}
	void setDecrementNumber(int k) {numDec=k;}
	
signals:
//	void signalTerminate();
	void signalDecLife();
//private slots:
//	virtual bool slotReceive(sieTransact* tr);
	
private:
	int numDec;
//	int currentTime;
	sieTransactList* transactList;
	
};

//----------------------------------------------------------

#endif
