#include "sietransactlist.h"
//----------------------------------------------------------
#include "sietransact.h"
//----------------------------------------------------------

sieTransactList::sieTransactList() : first(0), last(0)
{}

//----------------------------------------------------------

sieTransactList::~sieTransactList()
{
	removeAll();
}

//----------------------------------------------------------

void sieTransactList::removeAll()
{
	while(first)
		remove(first);
}

//----------------------------------------------------------

sieTransact* sieTransactList::create()
{
	sieTransact* tr=new sieTransact;
	if(first)
	{
		last->next=tr;
		last=tr;
	}
	else
	{
		first=last=tr;
	}
	last->next=0;
	return tr;
}

//----------------------------------------------------------

bool sieTransactList::remove(sieTransact* tr)
{
	if(!first) return false;
	if(!tr) return false;
	if(first==last)
	{
		if(tr==first)
		{
			delete first;
			first=last=0;
			return true;
		}
		return false;
	}
	sieTransact* p=first,*pp=0;

	while((p!=0)&&(p!=tr))
	{
		pp=p;
		p=p->next;
	}

	if(!p) return false;
	if(!pp)
	{
		first=p->next;

		delete p;
	}
	else
	{
		if(last==p) last=pp;
		pp->next=p->next;

		delete p;
	}
	return true;
}

//----------------------------------------------------------
